const GLib = imports.gi.GLib;
const GObject = imports.gi.GObject;
const Gio = imports.gi.Gio;
const Gtk = imports.gi.Gtk;

const Gettext = imports.gettext.domain('nls1729-extensions');
const _ = Gettext.gettext;

const ExtensionUtils = imports.misc.extensionUtils;
const Me = ExtensionUtils.getCurrentExtension();
const Convenience = Me.imports.convenience;

function init() {
    Convenience.initTranslations();
}

const ActivitiesButtonTextPrefsWidget = new GObject.Class({
    Name: 'Activities-Button-Text.Prefs.Widget',
    GTypeName: 'ActivitiesButtonTextPrefsWidget',
    Extends: Gtk.Grid,

    _init: function(params) {	
        this.parent(params);
        this.margin = this.row_spacing = this.column_spacing = 10;
	this._settings = Convenience.getSettings();
        this._binder = new Gtk.Entry({ editable: false });
	this._entry = new Gtk.Entry({ hexpand: true });
        let instructionText = _("To change the Activities Button Text. Enter new text then press Apply.");
        let newText = _("Activities Button Text:");
        let applyText = _("Apply");
	this.attach(new Gtk.Label({ label: '<b>' + instructionText + '</b>', wrap: true, use_markup: true  }), 0, 0, 4, 1);
        this.attach(new Gtk.Label({ label: newText, wrap: true }), 0, 2, 2, 1);
	this.attach(this._entry, 2, 2, 1, 1);
        let applyBtn = new Gtk.Button({ label: applyText });
        this.attach(applyBtn, 2, 4, 1, 1);
        applyBtn.connect("clicked", setActivitiesText);
        this._settings.bind('activities-button-text', this._binder, 'text', Gio.SettingsBindFlags.DEFAULT);
    }
});

let widget;

function setActivitiesText() {
    let text = widget._entry.get_text();
    widget._binder.set_text(text);
    widget._entry.set_text('');
}

function buildPrefsWidget() {
    widget = new ActivitiesButtonTextPrefsWidget();
    widget.show_all();
    widget._binder.hide();
    return widget;
}
